package ru.dbotthepony.kstarbound.network.packets

import ru.dbotthepony.kstarbound.Starbound
import ru.dbotthepony.kstarbound.defs.CelestialBaseInformation
import ru.dbotthepony.kstarbound.network.IServerPacket
import ru.dbotthepony.kstarbound.server.ServerConnection
import java.io.DataInputStream
import java.io.DataOutputStream
import java.util.UUID

data class ProtocolRequestPacket(val version: Int) : IServerPacket {
	constructor(stream: DataInputStream, isLegacy: Boolean) : this(stream.readInt())

	override fun write(stream: DataOutputStream, isLegacy: Boolean) {
		stream.writeInt(version)
	}

	override fun play(connection: ServerConnection) {
		if (version == Starbound.NATIVE_PROTOCOL_VERSION) {
			connection.sendAndFlush(ProtocolResponsePacket(true))
			connection.setupNative()
		} else if (version == Starbound.LEGACY_PROTOCOL_VERSION) {
			connection.sendAndFlush(ProtocolResponsePacket(true))
			connection.setupLegacy()
		} else {
			connection.sendAndFlush(ProtocolResponsePacket(false))
			connection.close()
		}
	}
}
