package ru.dbotthepony.kstarbound.server.network.packets

import ru.dbotthepony.kommons.io.readVector2d
import ru.dbotthepony.kommons.io.writeStruct2d
import ru.dbotthepony.kommons.vector.Vector2d
import ru.dbotthepony.kstarbound.network.IServerPacket
import ru.dbotthepony.kstarbound.server.ServerConnection
import java.io.DataInputStream
import java.io.DataOutputStream

data class TrackedPositionPacket(val pos: Vector2d) : IServerPacket {
	constructor(stream: DataInputStream, isLegacy: Boolean) : this(stream.readVector2d())

	override fun write(stream: DataOutputStream, isLegacy: Boolean) {
		stream.writeStruct2d(pos)
	}

	override fun play(connection: ServerConnection) {
		connection.trackedPosition = pos
	}
}